#### Beyond Linux® From Scratch (systemd Edition) - Version 10.1

### Chapter 4. Security

- Prev

  NSS-3.61

- Next

  p11-kit-0.23.22

- Up
- Home

# OpenSSH-8.4p1

## Introduction to OpenSSH

The OpenSSH package contains ssh clients and the sshd daemon. This is useful for encrypting authentication and subsequent traffic over a network. The ssh and scp commands are secure implementations of telnet and rcp respectively.

This package is known to build and work properly using an LFS-10.1 platform.

### Package Information

- Download (HTTP): http://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-8.4p1.tar.gz

- Download MD5 sum: 8f897870404c088e4aa7d1c1c58b526b

- Download size: 1.7 MB

- Estimated disk space required: 48 MB (add 17 MB for tests)

- Estimated build time: 0.2 SBU (Using parallelism=4; running the tests takes 20+ minutes, irrespective of processor speed)

### OpenSSH Dependencies

#### Optional

GDB-10.1 (for tests), Linux-PAM-1.5.1, X Window System, MIT Kerberos V5-1.19.1, libedit, LibreSSL Portable, OpenSC, and libsectok

#### Optional Runtime (Used only to gather entropy)

OpenJDK-15.0.2, Net-tools-CVS_20101030, and Sysstat-12.5.3

User Notes: http://wiki.linuxfromscratch.org/blfs/wiki/OpenSSH

## Installation of OpenSSH

OpenSSH runs as two processes when connecting to other computers. The first process is a privileged process and controls the issuance of privileges as necessary. The second process communicates with the network. Additional installation steps are necessary to set up the proper environment, which are performed by issuing the following commands as the `root` user:

    install  -v -m700 -d /var/lib/sshd &&
    chown    -v root:sys /var/lib/sshd &&

    groupadd -g 50 sshd        &&
    useradd  -c 'sshd PrivSep' \
             -d /var/lib/sshd  \
             -g sshd           \
             -s /bin/false     \
             -u 50 sshd

First, adapt ssh-copy-id to changes in bash-5.1:

    sed -e '/INSTALLKEYS_SH/s/)//' -e '260a\  )' -i contrib/ssh-copy-id

Install OpenSSH by running the following commands:

    ./configure --prefix=/usr                     \
                --sysconfdir=/etc/ssh             \
                --with-md5-passwords              \
                --with-privsep-path=/var/lib/sshd &&
    make

The testsuite requires an installed copy of scp to complete the multiplexing tests. To run the test suite, first copy the scp program to `/usr/bin`, making sure that you backup any existing copy first.

To test the results, issue: make -j1 tests.

Now, as the `root` user:

    make install &&
    install -v -m755    contrib/ssh-copy-id /usr/bin     &&

    install -v -m644    contrib/ssh-copy-id.1 \
                        /usr/share/man/man1              &&
    install -v -m755 -d /usr/share/doc/openssh-8.4p1     &&
    install -v -m644    INSTALL LICENCE OVERVIEW README* \
                        /usr/share/doc/openssh-8.4p1

## Command Explanations

`--sysconfdir=/etc/ssh`: This prevents the configuration files from being installed in `/usr/etc`.

`--with-md5-passwords`: This enables the use of MD5 passwords.

`--with-pam`: This parameter enables Linux-PAM support in the build.

`--with-xauth=/usr/bin/xauth`: Set the default location for the xauth binary for X authentication. Change the location if xauth will be installed to a different path. This can also be controlled from `sshd_config` with the XAuthLocation keyword. You can omit this switch if Xorg is already installed.

`--with-kerberos5=/usr`: This option is used to include Kerberos 5 support in the build.

`--with-libedit`: This option enables line editing and history features for sftp.

## Configuring OpenSSH

###

#### Config Files

`~/.ssh/*`, `/etc/ssh/ssh_config`, and `/etc/ssh/sshd_config`

There are no required changes to any of these files. However, you may wish to view the `/etc/ssh/` files and make any changes appropriate for the security of your system. One recommended change is that you disable `root` login via ssh. Execute the following command as the `root` user to disable `root` login via ssh:

    echo "PermitRootLogin no" >> /etc/ssh/sshd_config

If you want to be able to log in without typing in your password, first create ~/.ssh/id_rsa and ~/.ssh/id_rsa.pub with ssh-keygen and then copy ~/.ssh/id_rsa.pub to ~/.ssh/authorized_keys on the remote computer that you want to log into. You'll need to change REMOTE_USERNAME and REMOTE_HOSTNAME for the username and hostname of the remote computer and you'll also need to enter your password for the ssh-copy-id command to succeed:

    ssh-keygen &&
    ssh-copy-id -i ~/.ssh/id_rsa.pub REMOTE_USERNAME@REMOTE_HOSTNAME

Once you've got passwordless logins working it's actually more secure than logging in with a password (as the private key is much longer than most people's passwords). If you would like to now disable password logins, as the `root` user:

    echo "PasswordAuthentication no" >> /etc/ssh/sshd_config &&
    echo "ChallengeResponseAuthentication no" >> /etc/ssh/sshd_config

If you added Linux-PAM support and you want ssh to use it then you will need to add a configuration file for sshd and enable use of LinuxPAM. Note, ssh only uses PAM to check passwords, if you've disabled password logins these commands are not needed. If you want to use PAM, issue the following commands as the `root` user:

    sed 's@d/login@d/sshd@g' /etc/pam.d/login > /etc/pam.d/sshd &&
    chmod 644 /etc/pam.d/sshd &&
    echo "UsePAM yes" >> /etc/ssh/sshd_config

Additional configuration information can be found in the man pages for sshd, ssh and ssh-agent.

###

#### Systemd Unit

To start the SSH server at system boot, install the `sshd.service` unit included in the blfs-systemd-units-20210122 package.

    make install-sshd

## Contents

Installed Programs: scp, sftp, slogin (symlink to ssh), ssh, ssh-add, ssh-agent, ssh-copy-id, ssh-keygen, ssh-keyscan, and sshd
Installed Libraries: None
Installed Directories: /etc/ssh, /usr/share/doc/openssh-8.4p1, and /var/lib/sshd

### Short Descriptions

scp | is a file copy program that acts like rcp except it uses an encrypted protocol
sftp | is an FTP-like program that works over the SSH1 and SSH2 protocols
slogin | is a symlink to ssh
ssh | is an rlogin/rsh-like client program except it uses an encrypted protocol
sshd | is a daemon that listens for ssh login requests
ssh-add | is a tool which adds keys to the ssh-agent
ssh-agent | is an authentication agent that can store private keys
ssh-copy-id | is a script that enables logins on remote machine using local keys
ssh-keygen | is a key generation tool
ssh-keyscan | is a utility for gathering public host keys from a number of hosts

Last updated on 2021-02-19 11:32:42 -0800

- Prev

  NSS-3.61

- Next

  p11-kit-0.23.22

- Up
- Home